org.bouncycastle.jce.provider

## Class JCERSAPrivateCrtKey

- java.lang.Object
- - org.bouncycastle.jce.provider.JCERSAPrivateKey
  - - org.bouncycastle.jce.provider.JCERSAPrivateCrtKey

All Implemented Interfaces:
  java.io.Serializable, java.security.interfaces.RSAKey, java.security.interfaces.RSAPrivateCrtKey, java.security.interfaces.RSAPrivateKey, java.security.Key, java.security.PrivateKey, PKCS12BagAttributeCarrier

    public class JCERSAPrivateCrtKey
    extends JCERSAPrivateKey
    implements java.security.interfaces.RSAPrivateCrtKey

A provider representation for a RSA private key, with CRT factors included.

See Also:
  Serialized Form

### Field Summary

### Fields inherited from class org.bouncycastle.jce.provider.JCERSAPrivateKey

`modulus, privateExponent`

### Method Summary

Methods
`boolean` `equals(java.lang.Object o)`
`java.math.BigInteger` `getCrtCoefficient()` return the CRT coefficient.
`byte[]` `getEncoded()` Return a PKCS8 representation of the key.
`java.lang.String` `getFormat()` return the encoding format we produce in getEncoded().
`java.math.BigInteger` `getPrimeExponentP()` return the prime exponent for P.
`java.math.BigInteger` `getPrimeExponentQ()` return the prime exponent for Q.
`java.math.BigInteger` `getPrimeP()` return the prime P.
`java.math.BigInteger` `getPrimeQ()` return the prime Q.
`java.math.BigInteger` `getPublicExponent()` return the public exponent.
`int` `hashCode()`
`java.lang.String` `toString()`

### Methods inherited from class org.bouncycastle.jce.provider.JCERSAPrivateKey

`getAlgorithm, getBagAttribute, getBagAttributeKeys, getModulus, getPrivateExponent, setBagAttribute`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.security.interfaces.RSAPrivateKey

`getPrivateExponent`

### Methods inherited from interface java.security.Key

`getAlgorithm`

### Methods inherited from interface java.security.interfaces.RSAKey

`getModulus`

### Method Detail

#### getFormat

    public java.lang.String getFormat()

return the encoding format we produce in getEncoded().

Specified by:
  `getFormat` in interface `java.security.Key`
Overrides:
  `getFormat` in class `JCERSAPrivateKey`
Returns:
  the encoding format we produce in getEncoded().

#### getEncoded

    public byte[] getEncoded()

Return a PKCS8 representation of the key. The sequence returned represents a full PrivateKeyInfo object.

Specified by:
  `getEncoded` in interface `java.security.Key`
Overrides:
  `getEncoded` in class `JCERSAPrivateKey`
Returns:
  a PKCS8 representation of the key.

#### getPublicExponent

    public java.math.BigInteger getPublicExponent()

return the public exponent.

Specified by:
  `getPublicExponent` in interface `java.security.interfaces.RSAPrivateCrtKey`
Returns:
  the public exponent.

#### getPrimeP

    public java.math.BigInteger getPrimeP()

return the prime P.

Specified by:
  `getPrimeP` in interface `java.security.interfaces.RSAPrivateCrtKey`
Returns:
  the prime P.

#### getPrimeQ

    public java.math.BigInteger getPrimeQ()

return the prime Q.

Specified by:
  `getPrimeQ` in interface `java.security.interfaces.RSAPrivateCrtKey`
Returns:
  the prime Q.

#### getPrimeExponentP

    public java.math.BigInteger getPrimeExponentP()

return the prime exponent for P.

Specified by:
  `getPrimeExponentP` in interface `java.security.interfaces.RSAPrivateCrtKey`
Returns:
  the prime exponent for P.

#### getPrimeExponentQ

    public java.math.BigInteger getPrimeExponentQ()

return the prime exponent for Q.

Specified by:
  `getPrimeExponentQ` in interface `java.security.interfaces.RSAPrivateCrtKey`
Returns:
  the prime exponent for Q.

#### getCrtCoefficient

    public java.math.BigInteger getCrtCoefficient()

return the CRT coefficient.

Specified by:
  `getCrtCoefficient` in interface `java.security.interfaces.RSAPrivateCrtKey`
Returns:
  the CRT coefficient.

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `JCERSAPrivateKey`

#### equals

    public boolean equals(java.lang.Object o)

Overrides:
  `equals` in class `JCERSAPrivateKey`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`